
##############################################################################
#
# Copyright (c) 2005-2006 Balazs Ree <ree@greenfinity.hu> All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

'''\
Comment
'''
       
from base import Action

class CommentAction(Action):
    'Log text as comment'

    def __init__(self, txt='', header=None):
        self.header = header
        self.lines = []
        self.append(txt)
            
    def append(self, txt=''):
        'Can append text to this action'
        self.lines.extend(txt.splitlines())
        
    margin_length = 65
    margin_char = '*'
    replace_char = '~'
    border = 2
    
    def _gen_margin(self, writer, header=None):
        length = self.margin_length - writer.indent - 2
        r = self.replace_char
        s = self.margin_char
        b = self.border
        if header is None:
            formatted = s * length
        else:
            formatted = (b * r + header + b * r).replace(' ', r).center(length).replace(' ', s).replace(r, ' ')
        writer.write('# ' + formatted)
        writer.newline()
        
    def generate_header(self, writer, text=None):
        #writer.newline()
        self._gen_margin(writer, text)

    def generate_footer(self, writer):
        self._gen_margin(writer)
        writer.newline()

    def generate(self, writer):
        self.generate_header(writer, self.header)
        for line in self.lines:
            writer.write('# ' + line)
            writer.newline()
        self.generate_footer(writer)
