
##############################################################################
#
# Copyright (c) 2005-2006 Balazs Ree <ree@greenfinity.hu> All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

'''\
Set cookies
'''
       
from base import Action

class SetCookiesAction(Action):
    'Set cookies for the first request'

    def __init__(self, cookies):
        self.cookies = cookies
            
    def generate(self, writer):
        self.generate_header(writer, 'Setup cookies for the first page')
        writer.write('# Your browser emitted cookies in the first request of')
        writer.newline()
        writer.write('# the test. This probably means that it did not start from a clean state.')
        writer.newline()
        writer.write('# The following code sets up the initial cookies, but')
        writer.newline()
        writer.write('# you probably want to delete this and make sure the authentication')
        writer.newline()
        writer.write('# data is submitted in the first request instead.')
        writer.newline()
        writer.write('# (See the following line for an example to do this.)')
        writer.newline()
        writer.write('## %s.open(portal_url + "", data=urlencode(self.auth_dict)) ' % (writer.browservar, ))
        writer.newline()
        writer.write('#')
        writer.newline()
        writer.write('jar = %s._ua_handlers["_cookies"].cookiejar' % (writer.browservar, ))
        writer.newline()
        writer.write('domain = httplib.urlsplit(root_url)[1].split(":")[0]')
        writer.newline()
        for key, value in self.cookies.iteritems():
            writer.write('# %s = %s' % (repr(key), repr(value)))
            writer.newline()
            writer.write('jar.set_cookie(Cookie(version=0, name="%s", ' % (key, ))
            writer.write('value=\'"%s"\', ' % (value, ))
            writer.newline()
            writer.indenton()
            writer.write('port=None, port_specified=False, ')
            writer.write('domain=domain, domain_specified=False, domain_initial_dot=False, ')
            writer.write('path="/", path_specified=True, ')
            writer.write('secure=False, expires=None, discard=True, ')
            writer.write('comment=None, comment_url=None, ')
            writer.write('rest={}, rfc2109=False))') 
            writer.newline()
            writer.indentoff()
        self.generate_footer(writer)
