
##############################################################################
#
# Copyright (c) 2005-2006 Balazs Ree <ree@greenfinity.hu> All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

'''\
Checks the portal status on a response
'''

class PloneStatus(object):

    class BeautifulSoupMixin:
        
        def at_portalmessage(self):
            'Get the portal message'
            # get rid of <div id="cookies_message" class="portalMessage" style="display:none">
            return self.first('div', {'id':None, 'class': 'portalMessage'}).string.strip()

    def __init__(self, soup):
        self.portal_message = soup.at_portalmessage()
        if self.portal_message is soup.Null:
            self.portal_message = None

    def active(self):
        'Check if needs to be generated'
        return self.portal_message is not None

    def generate(self, writer):
        writer.write('# Checking Plone portal message')
        writer.newline()
        writer.write('self.assertEqual(soup.at_portalmessage(), %s)' % (repr(self.portal_message), ))
        writer.newline()
